;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>    ====             =====           ===        ===                      <<<<<<<<<<<<<<
;>>>>>>>>>  //      \\         //        \\        //    \\     //    \\      ||           <<<<<<<<<<<<<<
;>>>>>>>>> ||                 ||                  //      \\  //       \\     ||           <<<<<<<<<<<<<<
;>>>>>>>>>  \\====         ||                 //        \\//         \\    ||           <<<<<<<<<<<<<<
;>>>>>>>>>            \\      ||                ||                       ||   ||           <<<<<<<<<<<<<<
;>>>>>>>>>             ||     ||                ||                       ||   ||           <<<<<<<<<<<<<<
;>>>>>>>>>  \\====//        \\====//      ||                       ||   ======   <<<<<<<<<<<<<<
;>>>>>>>>>   Source     -    Code       -           Markup           - Language <<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Made by Frank Wiebeler <<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Copyright 2008 <<<<<<<<<<<<<<<<<<<<<<
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;->Interpreter for the (PB)-SCML-Interpreter


;Syntax
;{
; ";_ Initializes a Script"
; ";{+IDEVARS" Initializes a Set of Macros
; ";_?" Initializes a Pointer for this Line
; ";_ #Var=" Creates a Macro which can be called after any ;_ inside the Code
;  To Call (f.e. this) makro write #var#
; ";_ RUN Adr , Params" Runs the Spezified Program (f.e. a Browser to show some HTML-Help on this line)
; ";_GOTO ?Pointer@Filename.pb" : Jump to the spezified Pointer in the Spezified 
;      This Event is automatically mapped IN the Browser-Functions

;}
;{+IDEVARS
        ;_#GOOGLE=http://www.google.com
;}
;Commandline: "%FILE" "%CURSOR"
; German Forum Thread ;_RUN http://www.pure-board.de
; English Forum Thread ;_RUN http://forums.purebasic.com
; For any questions ask Google ;_RUN #GOOGLE#
;-Program-Start ;_GOTO ?Program_Start

IncludeFile "Functions.pb"

Global Filename.s
Global curpos_string.s
Global NewList macs.Function()
Global NewList Lines.s()
Global _bla_extractedNamePos.l
Global Filetext.s

Procedure EntfalteMacro(Macronen.s(),*Function.Function)
Protected id.l,pos.l
Static instanz=-1
      instanz=instanz+1   
      id=ListIndex(Macronen())
      LastElement(Macronen())
      pos=FindStringOutSideString(*Function\code,"#",1)
      While pos
          ForEach Macronen()
                If Macronen()=UCase(Mid(*Function\code,pos,Len(Macronen())))
                      ErrorMessage("Recursion in Macro-List found")
                EndIf  
          Next
          ForEach macs()
                If Macs()\name=UCase(Mid(*Function\code,pos,Len(Macs()\name)))
                          LastElement(Macronen())
                          AddElement(Macronen())
                          Macronen()=macs()\name
                          EntfalteMacro(Macronen(),@macs())
                          DeleteElement(Macronen())
                          LastElement(Macronen())
                          *Function\code=Left(*Function\code,pos-1)+macs()\code+Mid(*Function\code,pos+Len(macs()\name))
                          Break
                EndIf            
          Next
          pos=FindStringOutSideString(*Function\code,"#",pos)
      Wend 
      SelectElement(Macronen(),id)
      ProcedureReturn 0
EndProcedure

Procedure CreateMacroList()
    ForEach Lines()
          pos=FindStringOutSideString(Lines(),#startstring,1)
          If pos
                Lines()=Mid(Lines(),pos+2)
                If Left(Trim(Lines()),1)="#"
                    AddElement(macs())
                          macs()\name=UCase(Trim(StringField(Lines(),1,"=")))
                          If Right(macs()\name,1)<>"#"
                                  macs()\name=macs()\name+"#"
                          EndIf
                          macs()\code=Trim(StringField(Lines(),2,"="))
                EndIf
          EndIf
    Next
    ClearList(Lines())
    ;-Macros innerhalb der Macros entfalten
    Global   NewList Macronen.s()
    ForEach macs()
          FirstElement(Macronen())
          AddElement(Macronen())
          Macronen()=macs()\name
          EntfalteMacro(Macronen(),@macs())
          ClearList(Macronen())
    Next
EndProcedure


;Check, if its a function
Procedure IsFunction(text.s)
      text=UCase(text)
      If Left(text,3)="RUN"
            ProcedureReturn 1
      ElseIf Left(text,4)="GOTO"
            ProcedureReturn 1
      EndIf
EndProcedure

;Execute Function
Procedure WorkOutFunction(function.s)
Protected adress.s,pointer.s
            If UCase(Left(Function,3))="RUN"
                    adress=Trim(Mid(Function,4))
                  ;{ EnvironmentVariablen ersetzen
                    a=Int(CountString(adress,"%")/2) ;Enviroment-Variablen vorhanden
                    For b=1 To a
                            pos=0
                            For c=0 To 1
                                  pos=FindString(adress,"%",pos+1)
                            Next
                            adress=StringField(adress,1,"%")+GetEnvironmentVariable(StringField(adress,2,"%"))+Mid(adress,pos+1)
                    Next
                  ;}
                    pos=FindStringOutSideString(adress,",",1)
                    If pos
                          RunProgram(RemoveString(Left(adress,pos-1),Chr(34)),RemoveString(Mid(adress,pos+1),Chr(34)),GetPathPart(Filename))
                    Else
                          RunProgram(adress)
                    EndIf
            ElseIf UCase(Left(Function,4))="GOTO"
                    adress=Trim(Mid(Function,5))
                    pointer=StringField(adress,1,"@")
                    adress=StringField(adress,2,"@")
                    If adress=""
                        adress=Filename
                    ElseIf Mid(adress,2,1)<>":" ;Kein vollstndiger DAteipfad
                         adress=GetPathPart(Filename)+adress
                    EndIf
                    GotoSourcePointer(adress,pointer)
            EndIf
EndProcedure

Procedure MapMacros();Find all Macro-Declarations in the current File (%FILE)
              map=0
              For a=1 To CountString(Filetext,Chr(13)+Chr(10))
                   string.s=Mid(StringField(Filetext,a,Chr(13)+Chr(10)),2)
                   If map=0
                         If UCase(Left(Trim(string),10))=";{+IDEVARS"
                              map=1
                         EndIf
                   Else
                           string.s=Trim(string)
                           If Left(String,2)=";{"
                                map=map+1
                           ElseIf Left(String,2)=";}"
                                map=map-1
                           Else 
                               AddElement(Lines())
                                  Lines()=string
                           EndIf
                   EndIf
              Next
EndProcedure


Procedure.s ReplaceMacros(comment.s)
Protected pos,posplus,posstrich
Protected name.s
    If FindStringOutSideString(comment,"#",1)
            MapMacros()
            CreateMacroList()
            ForEach macs()
                  comment=ReplaceString(comment,macs()\name, macs()\code)
            Next 
            comment=UCase(comment)
    EndIf
    ProcedureReturn comment
EndProcedure

Procedure TranslateComment(comment.s,restline.s);Split all Functions in the current Line
    Protected NewList  Command.s()
                comment=ReplaceMacros(comment)
                AddElement(Command())
                    Command()=comment
                    pos=FindStringOutSideString(Command(),"|")
                    While pos<>0
                          comment=Mid(Command(),pos+1)
                          Command()=Left(Command(),pos-1)
                          AddElement(Command())
                          Command()=comment
                          pos=FindStringOutSideString(comment,"|",1)
                    Wend  
                    funccounts=0
                    ForEach Command()
                            If IsFunction(Command())
                                INC funccounts
                            EndIf
                    Next
                    If funccounts=0
                             ErrorMessage("No Callable Functions")
                    Else
                          ClearGadgetItemList(2)
                          ForEach Command() 
                                        WorkOutFunction(Command())
                          Next    
                    EndIf
EndProcedure


Procedure Main()
        If filename<>"" And FindString(curpos_string,"x",1);Check if Parameters were Valid
            zeile.l=Val(StringField(curpos_string,0,"x"));Getting the line, from where the plugin is Called
            GetEditorVars()
            Filetext.s=GetScintillaText(Scintilla)
            befehl.s=StringField(Filetext,zeile,Chr(13)+Chr(10))
            ;Den wichtigen Kommentar finden:
            pos=FindStringOutSideString(befehl,#startstring)
            If pos<>0
                    comment.s=Trim(Mid(befehl,pos+2))
                    TranslateComment(comment,befehl)
            Else 
                  ErrorMessage("No Command found")
            EndIf 
        Else
              ErrorMessage("Wrong Parameters")
        EndIf
EndProcedure

;_?Program_Start
filename.s=ProgramParameter(0)  ;%FILE
curpos_string.s=ProgramParameter(1) ;%CURSOR
Main()
AddHisEntry(filename,curpos_string)

; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 33
; FirstLine = 19
; Folding = --
; EnableAsm
; UseIcon = Icons\SCML.ico
; Executable = D:\Programme\PureBasic4.20\SCML\PBCML.exe